clear
clc

addpath('functions')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Import the survey data

% Wage beliefs at the end of college

% Cohort 2001, Freshmen Year
cd data\surveydata\zsurveyend01

% Graduate in 4 Years
Data_Raw = textread('SR-12G-01 PART1.txt');
Data_Temp = [];
n = 1;
for p = 1:size(Data_Raw,1)
    if Data_Raw(p,1) > 100000
        Data_Temp(n,:) = Data_Raw(p,:);
        n = n + 1;
    else
        Data_Temp(n - 1,2:end) = Data_Raw(p,1:(end - 1));
    end
end

Id_01_Survey = Data_Temp(:,1);       % Identifier
W_Y1_01_1 = Data_Temp(:,2:6);        % Wage belief: Cohort 2001, 1 year out, Graduate in 4 years
W_28_01_1 = Data_Temp(:,7:11);       % Wage belief: Cohort 2001, age 28, Graduate in 4 years
W_38_01_1 = Data_Temp(:,12:16);      % Wage belief: Cohort 2001, age 38, Graduate in 4 years

% Graduate in the Nov of the 5th Year
Data_Raw = textread('5thyr-2NOV-01 part1.txt');
Data_Temp = [];
n = 1;
for p = 1:size(Data_Raw,1)
    if Data_Raw(p,1) > 100000
        Data_Temp(n,:) = Data_Raw(p,:);
        n = n + 1;
    else
        Data_Temp(n - 1,2:end) = Data_Raw(p,1:(end - 1));
    end
end

W_Y1_01_2 = Data_Temp(:,2:6);        % Wage belief: Cohort 2001, 1 year out, Graduate in the Nov of the 5th Year
W_28_01_2 = Data_Temp(:,7:11);       % Wage belief: Cohort 2001, age 28, Graduate in the Nov of the 5th Year
W_38_01_2 = Data_Temp(:,12:16);      % Wage belief: Cohort 2001, age 38, Graduate in the Nov of the 5th Year

% Graduate in the May of the 5th Year
Data_Raw = textread('5thyr-2MAY-01 part1.txt');
Data_Temp = [];
n = 1;
for p = 1:size(Data_Raw,1)
    if Data_Raw(p,1) > 100000
        Data_Temp(n,:) = Data_Raw(p,:);
        n = n + 1;
    else
        Data_Temp(n - 1,2:end) = Data_Raw(p,1:(end - 1));
    end
end

W_Y1_01_3 = Data_Temp(:,2:6);        % Wage belief: Cohort 2001, 1 year out, Graduate in the May of the 5th Year
W_28_01_3 = Data_Temp(:,7:11);       % Wage belief: Cohort 2001, age 28, Graduate in the May of the 5th Year
W_38_01_3 = Data_Temp(:,12:16);      % Wage belief: Cohort 2001, age 38, Graduate in the May of the 5th Year

cd ..

cd zsurveyend00

% Graduate in 4 Years
Data_Raw = textread('SR-12G-00-427 part1.txt');
Data_Temp = [];
n = 1;
for p = 1:size(Data_Raw,1)
    if Data_Raw(p,1) > 100000
        Data_Temp(n,:) = Data_Raw(p,:);
        n = n + 1;
    else
        Data_Temp(n - 1,2:end) = Data_Raw(p,1:(end - 1));
    end
end

Id_00_Survey = Data_Temp(:,1);       % Identifier
W_Y1_00_1 = Data_Temp(:,2:6);        % Wage belief: Cohort 2000, 1 year out, Graduate in 4 years
W_28_00_1 = Data_Temp(:,7:11);       % Wage belief: Cohort 2000, age 28, Graduate in 4 years
W_38_00_1 = Data_Temp(:,12:16);      % Wage belief: Cohort 2000, age 38, Graduate in 4 years

% Graduate in the Nov of the 5th Year
Data_Raw = textread('5thyr-6G-00-427.txt');
Data_Temp = [];
n = 1;
for p = 1:size(Data_Raw,1)
    if Data_Raw(p,1) > 100000
        Data_Temp(n,:) = Data_Raw(p,:);
        n = n + 1;
    else
        Data_Temp(n - 1,2:end) = Data_Raw(p,1:(end - 1));
    end
end

W_Y1_00_2 = Data_Temp(:,2:6);        % Wage belief: Cohort 2000, 1 year out, Graduate in the Nov of the 5th Year
W_28_00_2 = Data_Temp(:,7:11);       % Wage belief: Cohort 2000, age 28, Graduate in the Nov of the 5th Year
W_38_00_2 = Data_Temp(:,12:16);      % Wage belief: Cohort 2000, age 38, Graduate in the Nov of the 5th Year

% Graduate in the May of the 5th Year
Data_Raw = textread('5thyr-12G-00-427 part1.txt');
Data_Temp = [];
n = 1;
for p = 1:size(Data_Raw,1)
    if Data_Raw(p,1) > 100000
        Data_Temp(n,:) = Data_Raw(p,:);
        n = n + 1;
    else
        Data_Temp(n - 1,2:end) = Data_Raw(p,1:(end - 1));
    end
end

W_Y1_00_3 = Data_Temp(:,2:6);        % Wage belief: Cohort 2000, 1 year out, Graduate in the May of the 5th Year
W_28_00_3 = Data_Temp(:,7:11);       % Wage belief: Cohort 2000, age 28, Graduate in the May of the 5th Year
W_38_00_3 = Data_Temp(:,12:16);      % Wage belief: Cohort 2000, age 38, Graduate in the May of the 5th Year

% Graduate in the 6th Year
Data_Raw = textread('6thyr-2-00-427 part1.txt');
Data_Temp = [];
n = 1;
for p = 1:size(Data_Raw,1)
    if Data_Raw(p,1) > 100000
        Data_Temp(n,:) = Data_Raw(p,:);
        n = n + 1;
    else
        Data_Temp(n - 1,2:end) = Data_Raw(p,1:(end - 1));
    end
end

W_Y1_00_4 = Data_Temp(:,2:6);        % Wage belief: Cohort 2000, 1 year out, Graduate in the 6th Year
W_28_00_4 = Data_Temp(:,7:11);       % Wage belief: Cohort 2000, age 28, Graduate in the 6th Year
W_38_00_4 = Data_Temp(:,12:16);      % Wage belief: Cohort 2000, age 38, Graduate in the 6th Year

cd ..
cd ..
cd ..
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Data Cleaning
% Wage data
W_Cell = {'W_Y1_01_1', 'W_28_01_1', 'W_38_01_1', 'W_Y1_01_2', 'W_28_01_2', 'W_38_01_2', 'W_Y1_01_3', 'W_28_01_3', 'W_38_01_3', ...
          'W_Y1_00_1', 'W_28_00_1', 'W_38_00_1', 'W_Y1_00_2', 'W_28_00_2', 'W_38_00_2', 'W_Y1_00_3', 'W_28_00_3', 'W_38_00_3', 'W_Y1_00_4', 'W_28_00_4', 'W_38_00_4'};
    
for i = 1:length(W_Cell)
    eval(['Index_' W_Cell{i} ' = (sum(' W_Cell{i} ' == 555 | ' W_Cell{i} ' == 999 | ' W_Cell{i} ' == 888,2) > 0 | logical(1 - isordered(' W_Cell{i} ')));']) % Missing data and non-ordered quantiles
    eval(['HH_' W_Cell{i} ' = ' W_Cell{i} '(:,5);'])
    eval(['Index_' W_Cell{i} '_Trim = HH_' W_Cell{i} ' > 250 | HH_' W_Cell{i} ' <= 0;']) % Trimming above: all students with wage upper bound greater than 250k
    eval(['Index_' W_Cell{i} ' = Index_' W_Cell{i} '_Trim | Index_' W_Cell{i} ';'])
end

% Construct end-of-college wage beliefs
% Cohort 2001
W_Y1_01 = W_Y1_01_3.*(1 - Index_W_Y1_01_3) + W_Y1_01_2.*Index_W_Y1_01_3.*(1 - Index_W_Y1_01_2) + W_Y1_01_1.*Index_W_Y1_01_3.*Index_W_Y1_01_2.*(1 - Index_W_Y1_01_1);   
W_28_01 = W_28_01_3.*(1 - Index_W_28_01_3) + W_28_01_2.*Index_W_28_01_3.*(1 - Index_W_28_01_2) + W_28_01_1.*Index_W_28_01_3.*Index_W_28_01_2.*(1 - Index_W_28_01_1);
W_38_01 = W_38_01_3.*(1 - Index_W_38_01_3) + W_38_01_2.*Index_W_38_01_3.*(1 - Index_W_38_01_2) + W_38_01_1.*Index_W_38_01_3.*Index_W_38_01_2.*(1 - Index_W_38_01_1);

Index_W_Y1_01 = Index_W_Y1_01_1 & Index_W_Y1_01_2 & Index_W_Y1_01_3; 
Index_W_28_01 = Index_W_28_01_1 & Index_W_28_01_2 & Index_W_28_01_3; 
Index_W_38_01 = Index_W_38_01_1 & Index_W_38_01_2 & Index_W_38_01_3; 

% Cohort 2000
W_Y1_00 = W_Y1_00_4.*(1 - Index_W_Y1_00_4) + W_Y1_00_3.*Index_W_Y1_00_4.*(1 - Index_W_Y1_00_3) + W_Y1_00_2.*Index_W_Y1_00_4.*Index_W_Y1_00_3.*(1 - Index_W_Y1_00_2) + W_Y1_00_1.*Index_W_Y1_00_4.*Index_W_Y1_00_3.*Index_W_Y1_00_2.*(1 - Index_W_Y1_00_1);   
W_28_00 = W_28_00_4.*(1 - Index_W_28_00_4) + W_28_00_3.*Index_W_28_00_4.*(1 - Index_W_28_00_3) + W_28_00_2.*Index_W_28_00_4.*Index_W_28_00_3.*(1 - Index_W_28_00_2) + W_28_00_1.*Index_W_28_00_4.*Index_W_28_00_3.*Index_W_28_00_2.*(1 - Index_W_28_00_1);
W_38_00 = W_38_00_4.*(1 - Index_W_38_00_4) + W_38_00_3.*Index_W_38_00_4.*(1 - Index_W_38_00_3) + W_38_00_2.*Index_W_38_00_4.*Index_W_38_00_3.*(1 - Index_W_38_00_2) + W_38_00_1.*Index_W_38_00_4.*Index_W_38_00_3.*Index_W_38_00_2.*(1 - Index_W_38_00_1);

Index_W_Y1_00 = Index_W_Y1_00_1 & Index_W_Y1_00_2 & Index_W_Y1_00_3 & Index_W_Y1_00_4; 
Index_W_28_00 = Index_W_28_00_1 & Index_W_28_00_2 & Index_W_28_00_3 & Index_W_28_00_4; 
Index_W_38_00 = Index_W_38_00_1 & Index_W_38_00_2 & Index_W_38_00_3 & Index_W_38_00_4; 

% Drop the observations with missing values
Index_01 = Index_W_Y1_01 | Index_W_28_01 | Index_W_38_01;
Index_00 = Index_W_Y1_00 | Index_W_28_00 | Index_W_38_00;

W_Cell_T = {'W_Y1_01', 'W_28_01', 'W_38_01', 'W_Y1_00', 'W_28_00', 'W_38_00'};

for i = 1:3
    eval([W_Cell_T{i} '(Index_01,:) = [];'])
end

for i = 4:6
    eval([W_Cell_T{i} '(Index_00,:) = [];'])
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Compute standard deviations
% Direct, Stepwise Uniform
S_Y1_SU = std_SU([W_Y1_00;W_Y1_01]);
S_28_SU = std_SU([W_28_00;W_28_01]);
S_38_SU = std_SU([W_38_00;W_38_01]);

mu_S_Y1_SU = mean(S_Y1_SU);
std_S_Y1_SU = std(S_Y1_SU);

mu_S_28_SU = mean(S_28_SU);
std_S_28_SU = std(S_28_SU);

mu_S_38_SU = mean(S_38_SU);
std_S_38_SU = std(S_38_SU);

% Direct, Log-normal
S_Y1_LN = std_LN([W_Y1_00;W_Y1_01]);
S_28_LN = std_LN([W_28_00;W_28_01]);
S_38_LN = std_LN([W_38_00;W_38_01]);

mu_S_Y1_LN = mean(S_Y1_LN);
std_S_Y1_LN = std(S_Y1_LN);

mu_S_28_LN = mean(S_28_LN);
std_S_28_LN = std(S_28_LN);

mu_S_38_LN = mean(S_38_LN);
std_S_38_LN = std(S_38_LN);

% Direct, Normal
S_Y1_N = std_N([W_Y1_00;W_Y1_01]);
S_28_N = std_N([W_28_00;W_28_01]);
S_38_N = std_N([W_38_00;W_38_01]);

mu_S_Y1_N = mean(S_Y1_N);
std_S_Y1_N = std(S_Y1_N);

mu_S_28_N = mean(S_28_N);
std_S_28_N = std(S_28_N);

mu_S_38_N = mean(S_38_N);
std_S_38_N = std(S_38_N);

Table_10 = [mu_S_Y1_SU,mu_S_28_SU,mu_S_38_SU;std_S_Y1_SU,std_S_28_SU,std_S_38_SU; ...
            mu_S_Y1_LN,mu_S_28_LN,mu_S_38_LN;std_S_Y1_LN,std_S_28_LN,std_S_38_LN; ...
            mu_S_Y1_N,mu_S_28_N,mu_S_38_N;std_S_Y1_N,std_S_28_N,std_S_38_N]

