clear
clc

addpath('functions')

% Compare Uncertainty at different point of time

% Cohort 2001, Freshmen Year
cd data\surveydata\zsurveyfresh01

% Survey 1
Data_Raw = textread('FRESH101.txt');
Data_Temp = [];
n = 1;
for p = 1:size(Data_Raw,1)
    if Data_Raw(p,1) > 100000
        Data_Temp(n,:) = Data_Raw(p,:);
        n = n + 1;
    else
        Data_Temp(n - 1,2:end) = Data_Raw(p,1:(end - 1));
    end
end

Id_01_Survey = Data_Temp(:,1);       % Identifier
W_Uncon_01_1_B = Data_Temp(:,52:56); % Wage belief: Unconditional, Cohort 2001, Year 1, Beginning

% Survey 10
Data_Raw = textread('FRESH1001.txt');
Data_Temp = [];
n = 1;
for p = 1:size(Data_Raw,1)
    if Data_Raw(p,1) > 100000
        Data_Temp(n,:) = Data_Raw(p,:);
        n = n + 1;
    else
        Data_Temp(n - 1,2:end) = Data_Raw(p,1:(end - 1));
    end
end

W_Uncon_01_1_E = Data_Temp(:,54:58); % Wage belief: Unconditional, Cohort 2001, Year 1, End

cd ..

% Cohort 2001, Sophomore Year
cd zsurveysoph01

% Survey 12
Data_Temp = importdata('SOPH-12-01.txt');

W_Uncon_01_2_E = Data_Temp(:,27:31); % Wage belief: Unconditional, Cohort 2001, Year 2, End

cd ..

% Cohort 2001, Junior Year
cd zsurveyjun01

% Survey 12
Data_Temp = importdata('Jr-12-01.txt');

W_Uncon_01_3_E = Data_Temp(:,17:21); % Wage belief: Unconditional, Cohort 2001, Year 3, End

cd ..

% Cohort 2001, End of College
cd('zsurveyend01')

% May 2005
Data_Temp = importdata('SR-12G-01 PART1.txt');
W_Uncon_01_End_1 = Data_Temp(:,7:11); % Wage belief: Unconditional, Cohort 2001, End of College, May 2005

% November 2005
Data_Temp = importdata('5thyr-2NOV-01 part1.txt');
W_Uncon_01_End_2 = Data_Temp(:,7:11); % Wage belief: Unconditional, Cohort 2001, End of College, NOV 2005

% May 2006
Data_Temp = importdata('5thyr-2MAY-01 part1.txt');
W_Uncon_01_End_3 = Data_Temp(:,7:11); % Wage belief: Unconditional, Cohort 2001, End of College, May 2006

% Combine the data
W_Uncon_01_End_1_Index = repmat(1 - (sum(W_Uncon_01_End_1 == 555 | W_Uncon_01_End_1 == 999 | W_Uncon_01_End_1 == 888,2) > 0),1,5);
W_Uncon_01_End_2_Index = repmat(1 - (sum(W_Uncon_01_End_2 == 555 | W_Uncon_01_End_2 == 999 | W_Uncon_01_End_2 == 888,2) > 0),1,5);
W_Uncon_01_End_3_Index = repmat(1 - (sum(W_Uncon_01_End_3 == 555 | W_Uncon_01_End_3 == 999 | W_Uncon_01_End_3 == 888,2) > 0),1,5);

W_Uncon_01_End = W_Uncon_01_End_3.*W_Uncon_01_End_3_Index + W_Uncon_01_End_2.*(1 - W_Uncon_01_End_3_Index).*W_Uncon_01_End_2_Index + W_Uncon_01_End_1.*(1 - W_Uncon_01_End_3_Index).*(1 - W_Uncon_01_End_2_Index).*W_Uncon_01_End_1_Index;

cd ..

% Cohort 2000, Freshmen Year
cd('zsurveyfresh00_2010')

% Survey 1
Data_Temp = importdata('FR-1-00.txt');

Id_00_Survey = Data_Temp(:,1);       % Identifier
W_Uncon_00_1_B = Data_Temp(:,67:71); % Wage belief: Unconditional, Cohort 2000, Year 1, Beginning

% Survey 9
Data_Temp = importdata('FR-9-00.txt');

W_Uncon_00_1_E = Data_Temp(:,37:41); % Wage belief: Unconditional, Cohort 2000, Year 1, End

cd ..

% Cohort 2000, Sophomore Year
cd zsurveysoph00

% Survey 6
Data_Temp = importdata('SOPH-6-00.txt');

W_Uncon_00_2_E = Data_Temp(:,44:48); % Wage belief: Unconditional, Cohort 2000, Year 2, End

cd ..

% Cohort 2000, Junior Year
cd zsurveyjun00

% Survey 12
Data_Temp = importdata('JR-12-00.txt');

W_Uncon_00_3_E = Data_Temp(:,17:21); % Wage belief: Unconditional, Cohort 2000, Year 3, End

cd ..

% Cohort 2000, End of College
cd('zsurveyend00')

% May 2004
Data_Temp = importdata('SR-12G-00-427 part1.txt');
W_Uncon_00_End_1 = Data_Temp(:,7:11); % Wage belief: Unconditional, Cohort 2000, End of College, May 2004

% November 2004
Data_Temp = importdata('5thyr-6G-00-427.txt');
W_Uncon_00_End_2 = Data_Temp(:,7:11); % Wage belief: Unconditional, Cohort 2000, End of College, NOV 2004

% May 2005
Data_Temp = importdata('5thyr-12G-00-427 part1.txt');
W_Uncon_00_End_3 = Data_Temp(:,7:11); % Wage belief: Unconditional, Cohort 2000, End of College, May 2005

% November 2005
Data_Temp = importdata('6thyr-2-00-427 part1.txt');
W_Uncon_00_End_4 = Data_Temp(:,7:11); % Wage belief: Unconditional, Cohort 2000, End of College, NOV 2005

% Combine the data
W_Uncon_00_End_1_Index = repmat(1 - (sum(W_Uncon_00_End_1 == 555 | W_Uncon_00_End_1 == 999 | W_Uncon_00_End_1 == 888,2) > 0),1,5);
W_Uncon_00_End_2_Index = repmat(1 - (sum(W_Uncon_00_End_2 == 555 | W_Uncon_00_End_2 == 999 | W_Uncon_00_End_2 == 888,2) > 0),1,5);
W_Uncon_00_End_3_Index = repmat(1 - (sum(W_Uncon_00_End_3 == 555 | W_Uncon_00_End_3 == 999 | W_Uncon_00_End_3 == 888,2) > 0),1,5);
W_Uncon_00_End_4_Index = repmat(1 - (sum(W_Uncon_00_End_4 == 555 | W_Uncon_00_End_4 == 999 | W_Uncon_00_End_4 == 888,2) > 0),1,5);

W_Uncon_00_End = W_Uncon_00_End_4.*W_Uncon_00_End_4_Index + W_Uncon_00_End_3.*(1 - W_Uncon_00_End_4_Index).*W_Uncon_00_End_3_Index + W_Uncon_00_End_2.*(1 - W_Uncon_00_End_4_Index).*(1 - W_Uncon_00_End_3_Index).*W_Uncon_00_End_2_Index + W_Uncon_00_End_1.*(1 - W_Uncon_00_End_4_Index).*(1 - W_Uncon_00_End_3_Index).*(1 - W_Uncon_00_End_2_Index).*W_Uncon_00_End_1_Index;

cd ..
cd ..
cd ..

% Save the data for future use
SS_W_Uncon_00_1_B = W_Uncon_00_1_B;
SS_W_Uncon_01_1_B = W_Uncon_01_1_B;
SS_W_Uncon_00_1_E = W_Uncon_00_1_E;
SS_W_Uncon_01_1_E = W_Uncon_01_1_E;
SS_W_Uncon_00_2_E = W_Uncon_00_2_E;
SS_W_Uncon_01_2_E = W_Uncon_01_2_E;
SS_W_Uncon_00_3_E = W_Uncon_00_3_E;
SS_W_Uncon_01_3_E = W_Uncon_01_3_E;
SS_W_Uncon_00_End = W_Uncon_00_End;
SS_W_Uncon_01_End = W_Uncon_01_End;

% Clean data
% Drop the observations with missing values
W_Cell = {'W_Uncon_00_1_B', 'W_Uncon_00_1_E', 'W_Uncon_00_2_E', 'W_Uncon_00_3_E', ...
          'W_Uncon_01_1_B', 'W_Uncon_01_1_E', 'W_Uncon_01_2_E', 'W_Uncon_01_3_E'};

for i = 1:length(W_Cell)
    eval(['Index_' W_Cell{i} ' = (sum(' W_Cell{i} ' == 555 | ' W_Cell{i} ' == 999 | ' W_Cell{i} ' == 888,2) > 0 | logical(1 - isordered(' W_Cell{i} ')));']) % Missing data and non-ordered quantiles
    eval(['HH_' W_Cell{i} ' = ' W_Cell{i} '(:,5);'])
    eval(['Index_' W_Cell{i} '_Trim = HH_' W_Cell{i} ' > 250;']) % Trimming above: all students with wage upper bound greater than 250k
end

Index_W_Uncon_00_End = (W_Uncon_00_End(:,5) == 0 | logical(1 - isordered(W_Uncon_00_End)));
Index_W_Uncon_01_End = (W_Uncon_01_End(:,5) == 0 | logical(1 - isordered(W_Uncon_01_End)));

Index_W_Uncon_00_End_Trim = W_Uncon_00_End(:,5) > 250;
Index_W_Uncon_01_End_Trim = W_Uncon_01_End(:,5) > 250;

% Same sample
Index_SS_00 = Index_W_Uncon_00_1_B_Trim | Index_W_Uncon_00_1_B | ...
              Index_W_Uncon_00_1_E_Trim | Index_W_Uncon_00_1_E | ...
              Index_W_Uncon_00_2_E_Trim | Index_W_Uncon_00_2_E | ...
              Index_W_Uncon_00_3_E_Trim | Index_W_Uncon_00_3_E | ...
              Index_W_Uncon_00_End_Trim | Index_W_Uncon_00_End; 
          
Index_SS_01 = Index_W_Uncon_01_1_B_Trim | Index_W_Uncon_01_1_B | ...
              Index_W_Uncon_01_1_E_Trim | Index_W_Uncon_01_1_E | ...
              Index_W_Uncon_01_2_E_Trim | Index_W_Uncon_01_2_E | ...
              Index_W_Uncon_01_3_E_Trim | Index_W_Uncon_01_3_E | ...
              Index_W_Uncon_01_End_Trim | Index_W_Uncon_01_End; 
           
% Year 1: Beginning
SS_W_Uncon_00_1_B(Index_SS_00,:) = []; % Cohort 2000
SS_W_Uncon_01_1_B(Index_SS_01,:) = []; % Cohort 2001
SS_W_Uncon_1_B = [SS_W_Uncon_00_1_B; SS_W_Uncon_01_1_B];

N_SS = size(SS_W_Uncon_1_B, 1);

SS_std_Uncon_1_B_N = std_N(SS_W_Uncon_1_B);
SS_MN_std_Uncon_1_B_N = mean(SS_std_Uncon_1_B_N);
SS_std_std_Uncon_1_B_N = std(SS_std_Uncon_1_B_N);

SS_std_Uncon_1_B_LN = std_LN(SS_W_Uncon_1_B);
SS_MN_std_Uncon_1_B_LN = mean(SS_std_Uncon_1_B_LN);
SS_std_std_Uncon_1_B_LN = std(SS_std_Uncon_1_B_LN);

SS_std_Uncon_1_B_SU = std_SU(SS_W_Uncon_1_B);
SS_MN_std_Uncon_1_B_SU = mean(SS_std_Uncon_1_B_SU);
SS_std_std_Uncon_1_B_SU = std(SS_std_Uncon_1_B_SU);

% Year 1: End
SS_W_Uncon_00_1_E(Index_SS_00,:) = []; % Cohort 2000
SS_W_Uncon_01_1_E(Index_SS_01,:) = []; % Cohort 2001
SS_W_Uncon_1_E = [SS_W_Uncon_00_1_E; SS_W_Uncon_01_1_E];

SS_std_Uncon_1_E_N = std_N(SS_W_Uncon_1_E);
SS_MN_std_Uncon_1_E_N = mean(SS_std_Uncon_1_E_N);
SS_std_std_Uncon_1_E_N = std(SS_std_Uncon_1_E_N);

SS_std_Uncon_1_E_LN = std_LN(SS_W_Uncon_1_E);
SS_MN_std_Uncon_1_E_LN = mean(SS_std_Uncon_1_E_LN);
SS_std_std_Uncon_1_E_LN = std(SS_std_Uncon_1_E_LN);

SS_std_Uncon_1_E_SU = std_SU(SS_W_Uncon_1_E);
SS_MN_std_Uncon_1_E_SU = mean(SS_std_Uncon_1_E_SU);
SS_std_std_Uncon_1_E_SU = std(SS_std_Uncon_1_E_SU);

% Year 2: End
SS_W_Uncon_00_2_E(Index_SS_00,:) = []; % Cohort 2000
SS_W_Uncon_01_2_E(Index_SS_01,:) = []; % Cohort 2001
SS_W_Uncon_2_E = [SS_W_Uncon_00_2_E; SS_W_Uncon_01_2_E];

SS_std_Uncon_2_E_N = std_N(SS_W_Uncon_2_E);
SS_MN_std_Uncon_2_E_N = mean(SS_std_Uncon_2_E_N);
SS_std_std_Uncon_2_E_N = std(SS_std_Uncon_2_E_N);

SS_std_Uncon_2_E_LN = std_LN(SS_W_Uncon_2_E);
SS_MN_std_Uncon_2_E_LN = mean(SS_std_Uncon_2_E_LN);
SS_std_std_Uncon_2_E_LN = std(SS_std_Uncon_2_E_LN);

SS_std_Uncon_2_E_SU = std_SU(SS_W_Uncon_2_E);
SS_MN_std_Uncon_2_E_SU = mean(SS_std_Uncon_2_E_SU);
SS_std_std_Uncon_2_E_SU = std(SS_std_Uncon_2_E_SU);

% Year 3: End
SS_W_Uncon_00_3_E(Index_SS_00,:) = []; % Cohort 2000
SS_W_Uncon_01_3_E(Index_SS_01,:) = []; % Cohort 2001
SS_W_Uncon_3_E = [SS_W_Uncon_00_3_E; SS_W_Uncon_01_3_E];

SS_std_Uncon_3_E_N = std_N(SS_W_Uncon_3_E);
SS_MN_std_Uncon_3_E_N = mean(SS_std_Uncon_3_E_N);
SS_std_std_Uncon_3_E_N = std(SS_std_Uncon_3_E_N);

SS_std_Uncon_3_E_LN = std_LN(SS_W_Uncon_3_E);
SS_MN_std_Uncon_3_E_LN = mean(SS_std_Uncon_3_E_LN);
SS_std_std_Uncon_3_E_LN = std(SS_std_Uncon_3_E_LN);

SS_std_Uncon_3_E_SU = std_SU(SS_W_Uncon_3_E);
SS_MN_std_Uncon_3_E_SU = mean(SS_std_Uncon_3_E_SU);
SS_std_std_Uncon_3_E_SU = std(SS_std_Uncon_3_E_SU);

% End of College
SS_W_Uncon_00_End(Index_SS_00,:) = []; % Cohort 2000
SS_W_Uncon_01_End(Index_SS_01,:) = []; % Cohort 2001
SS_W_Uncon_End = [SS_W_Uncon_00_End; SS_W_Uncon_01_End];

SS_std_Uncon_End_N = std_N(SS_W_Uncon_End);
SS_MN_std_Uncon_End_N = mean(SS_std_Uncon_End_N);
SS_std_std_Uncon_End_N = std(SS_std_Uncon_End_N);

SS_std_Uncon_End_LN = std_LN(SS_W_Uncon_End);
SS_MN_std_Uncon_End_LN = mean(SS_std_Uncon_End_LN);
SS_std_std_Uncon_End_LN = std(SS_std_Uncon_End_LN);

SS_std_Uncon_End_SU = std_SU(SS_W_Uncon_End);
SS_MN_std_Uncon_End_SU = mean(SS_std_Uncon_End_SU);
SS_std_std_Uncon_End_SU = std(SS_std_Uncon_End_SU);

% Fraction of Uncertainty Resolved
Fr_1_E_N = 1 - (SS_MN_std_Uncon_1_E_N/SS_MN_std_Uncon_1_B_N)^2;
Fr_2_E_N = 1 - (SS_MN_std_Uncon_2_E_N/SS_MN_std_Uncon_1_B_N)^2;
Fr_3_E_N = 1 - (SS_MN_std_Uncon_3_E_N/SS_MN_std_Uncon_1_B_N)^2;
Fr_End_N = 1 - (SS_MN_std_Uncon_End_N/SS_MN_std_Uncon_1_B_N)^2;

Fr_1_E_LN = 1 - (SS_MN_std_Uncon_1_E_LN/SS_MN_std_Uncon_1_B_LN)^2;
Fr_2_E_LN = 1 - (SS_MN_std_Uncon_2_E_LN/SS_MN_std_Uncon_1_B_LN)^2;
Fr_3_E_LN = 1 - (SS_MN_std_Uncon_3_E_LN/SS_MN_std_Uncon_1_B_LN)^2;
Fr_End_LN = 1 - (SS_MN_std_Uncon_End_LN/SS_MN_std_Uncon_1_B_LN)^2;

Fr_1_E_SU = 1 - (SS_MN_std_Uncon_1_E_SU/SS_MN_std_Uncon_1_B_SU)^2;
Fr_2_E_SU = 1 - (SS_MN_std_Uncon_2_E_SU/SS_MN_std_Uncon_1_B_SU)^2;
Fr_3_E_SU = 1 - (SS_MN_std_Uncon_3_E_SU/SS_MN_std_Uncon_1_B_SU)^2;
Fr_End_SU = 1 - (SS_MN_std_Uncon_End_SU/SS_MN_std_Uncon_1_B_SU)^2;

Table_8 = [SS_MN_std_Uncon_1_B_SU,SS_MN_std_Uncon_1_E_SU,SS_MN_std_Uncon_2_E_SU,SS_MN_std_Uncon_3_E_SU,SS_MN_std_Uncon_End_SU; ...
         SS_MN_std_Uncon_1_B_LN,SS_MN_std_Uncon_1_E_LN,SS_MN_std_Uncon_2_E_LN,SS_MN_std_Uncon_3_E_LN,SS_MN_std_Uncon_End_LN; ...
         SS_MN_std_Uncon_1_B_N,SS_MN_std_Uncon_1_E_N,SS_MN_std_Uncon_2_E_N,SS_MN_std_Uncon_3_E_N,SS_MN_std_Uncon_End_N; ...
         NaN,Fr_1_E_SU,Fr_2_E_SU,Fr_3_E_SU,Fr_End_SU; ...
         NaN,Fr_1_E_LN,Fr_2_E_LN,Fr_3_E_LN,Fr_End_LN; ...
         NaN,Fr_1_E_N,Fr_2_E_N,Fr_3_E_N,Fr_End_N;]
     
