function [ beta_major ] = Estimation_Major( E_W, var_W, Prob_M, Regs )

N_M = size(Prob_M,2) - 1;

% Estimate the conditional means
beta_M = regress(E_W,[Prob_M(:,1:N_M),Regs]);

% Compute the first term on the RHS
RHS_1 = std_major(repmat([beta_M(1:N_M);0]',[size(Prob_M,1),1]),Prob_M).^2;

% Compute the measured second term on the RHS
RHS_2 = var_W - RHS_1;

% Estimate the conditional variance
beta_var = regress(RHS_2,[Prob_M(:,1:N_M),Regs]);

beta_major = [beta_M(1:N_M);beta_var(1:N_M)]';

end

