function [ beta_major, std_beta_major, CI_beta_major, beta_var ] = Estimation_Major_Bootstrap( E_W, var_W, Prob_M, Regs, alpha, N )

rng(1)
N_M = size(Prob_M,2) - 1;

% Estimate the conditional means
beta_M = regress(E_W,[Prob_M(:,1:N_M),Regs]);

% Compute the first term on the RHS
RHS_1 = std_major(repmat([beta_M(1:N_M);0]',[size(Prob_M,1),1]),Prob_M).^2;

% Compute the measured second term on the RHS
RHS_2 = var_W - RHS_1;

% Estimate the conditional variance
beta_var = regress(RHS_2,[Prob_M(:,1:N_M),Regs]);

beta_major = [beta_M(1:N_M);beta_var(1:N_M)]';

% Bootstrap the std and CI
E_W_predicted = [Prob_M(:,1:N_M),Regs]*beta_M;
var_W_predicted = [Prob_M(:,1:N_M),Regs]*beta_var + RHS_1;

error_M = E_W - E_W_predicted;
error_var = var_W - var_W_predicted;

K = size(Prob_M,1);
beta_major_temp = zeros(N,2*N_M);

for ind = 1:N
    E_W_temp = E_W_predicted + datasample(error_M,K);
    var_W_temp = var_W_predicted + datasample(error_var,K);
    beta_major_temp(ind,:) = Estimation_Major( E_W_temp, var_W_temp, Prob_M, Regs );
end
    
% std
std_beta_major = std(beta_major_temp);

% CI
CI_beta_major = zeros(2,2*N_M);
for i = 1:2*N_M
    CI_beta_major(:,i) = [prctile(beta_major_temp(:,i),alpha/2);prctile(beta_major_temp(:,i),100 - alpha/2)];
end

end

