function [ CriE ] = Obj_eps( Pg, Pe, muG, sigmaG, sigmaE)
% This function calculates the weighted sum of discrepancies between observed and model implied probabilities.
% We have information on the distribution of epsilon

CriE = (normcdf(0.25,0,sigmaE) - 0.5)*(normcdf(0.25,0,sigmaE) - 0.5 - Pe(1)/2)^2 + (normcdf(0.5,0,sigmaE) - normcdf(0.25,0,sigmaE))*(normcdf(0.5,0,sigmaE) - normcdf(0.25,0,sigmaE) - Pe(2)/2)^2 + (1 - normcdf(0.5,0,sigmaE))*(1 - normcdf(0.5,0,sigmaE) - Pe(3)/2)^2 + (normcdf(0.25,0,sigmaE) - 0.5)*(normcdf(0.25,0,sigmaE) - 0.5 - Pe(4)/2)^2 + (normcdf(0.5,0,sigmaE) - normcdf(0.25,0,sigmaE))*(normcdf(0.5,0,sigmaE) - normcdf(0.25,0,sigmaE) - Pe(5)/2)^2 + (1 - normcdf(0.5,0,sigmaE))*(1 - normcdf(0.5,0,sigmaE) - Pe(6)/2)^2 ...
       + (1 - normcdf(3.5,muG,sqrt(sigmaE^2+sigmaG^2)))*(1 - normcdf(3.5,muG,sqrt(sigmaE^2+sigmaG^2)) - Pg(1))^2 + (normcdf(3.5,muG,sqrt(sigmaE^2+sigmaG^2)) - normcdf(3,muG,sqrt(sigmaE^2+sigmaG^2)))*(normcdf(3.5,muG,sqrt(sigmaE^2+sigmaG^2)) - normcdf(3,muG,sqrt(sigmaE^2+sigmaG^2)) - Pg(2))^2 ...
       + (normcdf(3,muG,sqrt(sigmaE^2+sigmaG^2)) - normcdf(2.5,muG,sqrt(sigmaE^2+sigmaG^2)))*(normcdf(3,muG,sqrt(sigmaE^2+sigmaG^2)) - normcdf(2.5,muG,sqrt(sigmaE^2+sigmaG^2)) - Pg(3))^2 + (normcdf(2.5,muG,sqrt(sigmaE^2+sigmaG^2)) - normcdf(2,muG,sqrt(sigmaE^2+sigmaG^2)))*(normcdf(2.5,muG,sqrt(sigmaE^2+sigmaG^2)) - normcdf(2,muG,sqrt(sigmaE^2+sigmaG^2)) - Pg(4))^2 ...
       + (normcdf(2,muG,sqrt(sigmaE^2+sigmaG^2)) - normcdf(1,muG,sqrt(sigmaE^2+sigmaG^2)))*(normcdf(2,muG,sqrt(sigmaE^2+sigmaG^2)) - normcdf(1,muG,sqrt(sigmaE^2+sigmaG^2)) - Pg(5))^2 + normcdf(1,muG,sqrt(sigmaE^2+sigmaG^2))*(normcdf(1,muG,sqrt(sigmaE^2+sigmaG^2)) - Pg(6))^2;
end

