function [ mu_lambda_G_2 ] = lambda_G( G, N )
% This function calculates the value of E(lambda_G^2)

rng(1)
TempR = randn(9,N);
TempT = G(:,1)*ones(1,N) + G(:,2)*TempR(1,:);

TempG = zeros(size(G,1),N);

for i = 1:8
    TempE = G(:,3)*TempR(i+1,:);
    Tempg = TempT + TempE;
    Tempg(Tempg < 0) = 0;
    Tempg(Tempg > 4) = 4;
    TempG = TempG + Tempg;
end

TempG = TempG/8;

lambda_G_200_draw = (TempG < 3 & TempG >= 2).*(3 - TempG);
lambda_G_300_draw = (TempG < 3 & TempG >= 2).*(TempG - 2) + (TempG >= 3).*(1 - (TempG - 3)/0.75);
lambda_G_375_draw = (TempG >= 3).*(TempG - 3)/0.75;

lambda_G_200 = zeros(size(G,1),1);
lambda_G_300 = zeros(size(G,1),1);
lambda_G_375 = zeros(size(G,1),1);

for i = 1:size(G,1)
    lambda_G_200_Temp = lambda_G_200_draw(i,:);
    lambda_G_300_Temp = lambda_G_300_draw(i,:);
    lambda_G_375_Temp = lambda_G_375_draw(i,:);
    
    lambda_G_200(i) = mean(lambda_G_200_Temp(TempG(i,:) >= 2),2);
    lambda_G_300(i) = mean(lambda_G_300_Temp(TempG(i,:) >= 2),2);
    lambda_G_375(i) = mean(lambda_G_375_Temp(TempG(i,:) >= 2),2);
end

mu_lambda_G_200_2 = mean(lambda_G_200.^2);
mu_lambda_G_300_2 = mean(lambda_G_300.^2);
mu_lambda_G_375_2 = mean(lambda_G_375.^2);

mu_lambda_G_2 = [mu_lambda_G_200_2, mu_lambda_G_300_2, mu_lambda_G_375_2];
