function [obj_sum] = obj_P_M(rho,Para_G,Prob_M,GPA_M,N)
% This function computes the sum of squared differences between computed
% probabiliy and elicited probability of final major

M = size(Prob_M,1);  % Number of Majors

% Generate random realizations of G_it
RL_G = rnd_G(Para_G,N,1);

% Compute conditional probabilities of each major at each G_it realizations
temp_M_1 = repmat([rho(1:(M - 1));0],[1,size(RL_G,2)]) + [rho(M:end);0]*RL_G;
temp_M_2 = exp(temp_M_1 - max(temp_M_1,[],1))';
Prob_M_G = temp_M_2./repmat(sum(temp_M_2,2),[1,M]);

% Compute unconditional probabilities using both methods
% Method 1:
Prob_M_C_1 = mean(Prob_M_G,1)';

% Method 2:
Prob_M_C_2 = (mean(Prob_M_G.*repmat(RL_G',[1,M]),1)./GPA_M)';

% Compute the sum of squared differences
obj_sum = sum((Prob_M_C_1 - Prob_M).^2) + sum((Prob_M_C_2 - Prob_M).^2);

end

