function [ beta_M, beta_var ] = p_Estimation_Major( E_W, var_W, Prob_M, Regs, ind )

N_M = size(Prob_M,2) - 1;
% Estimate the conditional means
Prob_M_M = Prob_M;
if ind <= size(Prob_M,2) - 1
    Prob_M_M(:,ind) = [];
end

N_M_M = size(Prob_M_M,2) - 1;

beta_M = regress(E_W,[Prob_M_M(:,1:N_M_M),Regs]);

% Compute the first term on the RHS
if ind <= size(Prob_M,2) - 1
    rank_temp = linspace(1,N_M_M + size(Regs,2),N_M_M + size(Regs,2));
    beta_M = [beta_M(rank_temp < ind); 0; beta_M(rank_temp >= ind) ];
end

RHS_1 = std_major(repmat([beta_M(1:N_M);0]',[size(Prob_M,1),1]),Prob_M).^2;

% Compute the measured second term on the RHS
RHS_2 = var_W - RHS_1;

% Estimate the conditional variance
Prob_M_var = Prob_M;
if ind > size(Prob_M,2) - 1
    Prob_M_var(:,(ind - (size(Prob_M,2) - 1))) = [];
end

N_M_var = size(Prob_M_var,2) - 1;

beta_var = regress(RHS_2,[Prob_M_var(:,1:N_M_var),Regs]);

if ind > size(Prob_M,2) - 1
    rank_temp = linspace(1,N_M_var + size(Regs,2),N_M_var + size(Regs,2));
    beta_var = [beta_var(rank_temp < (ind - (size(Prob_M,2) - 1))); 0; beta_var(rank_temp >= (ind - (size(Prob_M,2) - 1))) ];
end

end

