function [ p_value ] = p_value_Major_Bootstrap( E_W, var_W, Prob_M, Regs, N )

rng(1)
N_M = size(Prob_M,2) - 1;

% Estimate the unrestricted model
% Estimate the conditional means
beta_M = regress(E_W,[Prob_M(:,1:N_M),Regs]);

% Compute the first term on the RHS
RHS_1 = std_major(repmat([beta_M(1:N_M);0]',[size(Prob_M,1),1]),Prob_M).^2;

% Compute the measured second term on the RHS
RHS_2 = var_W - RHS_1;

% Estimate the conditional variance
beta_var = regress(RHS_2,[Prob_M(:,1:N_M),Regs]);

beta_major = [beta_M(1:N_M);beta_var(1:N_M)]';

% Estimate the restricted models
p_value = zeros(2*N_M,1);

for i = 1:2*N_M
    [ beta_M_res_temp, beta_var_res_temp ] = p_Estimation_Major( E_W, var_W, Prob_M, Regs, i );
    E_W_predicted_res = [Prob_M(:,1:N_M),Regs]*beta_M_res_temp;
    var_W_predicted_res = [Prob_M(:,1:N_M),Regs]*beta_var_res_temp + std_major(repmat([beta_M_res_temp(1:N_M);0]',[size(Prob_M,1),1]),Prob_M).^2;
    error_M_res = E_W - E_W_predicted_res;
    error_var_res = var_W - var_W_predicted_res;
    K = size(Prob_M,1);
    beta_test_temp = zeros(N,1);
    for ind = 1:N
        E_W_temp = E_W_predicted_res + datasample(error_M_res,K);
        var_W_temp = var_W_predicted_res + datasample(error_var_res,K);
        beta_major_temp = Estimation_Major( E_W_temp, var_W_temp, Prob_M, Regs );
        beta_test_temp(ind) = beta_major_temp(i);
    end
    p_value(i) = 2*min(sum(beta_major(i) < beta_test_temp),sum(beta_major(i) >= beta_test_temp))/N;
end

end

