function [ Std ] = std_SU( X )
% This function calculates the standard deviations of students' wage distributions, assuming that the distributions are stepwise uniform. 
% X is a N*5 matrix: N students, each has five values.
% m is a N*1 vector: the standard deviations

N = size(X,1);
m = zeros(N,1);

for i = 1:4
    m = m + (X(:,i) + X(:,i+1))/8;
end

temp = zeros(N,1);

for i = 1:4
    temp = temp + (X(:,i).^2 + X(:,i+1).^2 + X(:,i).*X(:,i+1))/12;
end

Std = sqrt(temp - m.^2);

end

